// Implementation file for parser generated by fsyacc
module CPar
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open FSharp.Text.Lexing
open FSharp.Text.Parsing.ParseHelpers
# 1 "CPar.fsy"

(*	File ListC/CPar.fsy 
	Parser specification for list-C, a small imperative language with lists
	sestoft@itu.dk * 2009-10-18
	No (real) shift/reduce conflicts thanks to Niels Kokholm.
*)

open Absyn;

let compose1 f (g, s) = ((fun x -> g(f(x))), s)
let nl = CstI 10

# 19 "CPar.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | EOF
  | LPAR
  | RPAR
  | LBRACE
  | RBRACE
  | LBRACK
  | RBRACK
  | SEMI
  | COMMA
  | ASSIGN
  | AMP
  | NOT
  | SEQOR
  | SEQAND
  | EQ
  | NE
  | GT
  | LT
  | GE
  | LE
  | PLUS
  | MINUS
  | TIMES
  | DIV
  | MOD
  | NIL
  | CONS
  | CAR
  | CDR
  | DYNAMIC
  | SETCAR
  | SETCDR
  | CHAR
  | ELSE
  | IF
  | INT
  | NULL
  | PRINT
  | PRINTLN
  | RETURN
  | VOID
  | WHILE
  | CSTSTRING of (string)
  | NAME of (string)
  | CSTINT of (int)
  | CSTBOOL of (int)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_EOF
    | TOKEN_LPAR
    | TOKEN_RPAR
    | TOKEN_LBRACE
    | TOKEN_RBRACE
    | TOKEN_LBRACK
    | TOKEN_RBRACK
    | TOKEN_SEMI
    | TOKEN_COMMA
    | TOKEN_ASSIGN
    | TOKEN_AMP
    | TOKEN_NOT
    | TOKEN_SEQOR
    | TOKEN_SEQAND
    | TOKEN_EQ
    | TOKEN_NE
    | TOKEN_GT
    | TOKEN_LT
    | TOKEN_GE
    | TOKEN_LE
    | TOKEN_PLUS
    | TOKEN_MINUS
    | TOKEN_TIMES
    | TOKEN_DIV
    | TOKEN_MOD
    | TOKEN_NIL
    | TOKEN_CONS
    | TOKEN_CAR
    | TOKEN_CDR
    | TOKEN_DYNAMIC
    | TOKEN_SETCAR
    | TOKEN_SETCDR
    | TOKEN_CHAR
    | TOKEN_ELSE
    | TOKEN_IF
    | TOKEN_INT
    | TOKEN_NULL
    | TOKEN_PRINT
    | TOKEN_PRINTLN
    | TOKEN_RETURN
    | TOKEN_VOID
    | TOKEN_WHILE
    | TOKEN_CSTSTRING
    | TOKEN_NAME
    | TOKEN_CSTINT
    | TOKEN_CSTBOOL
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startMain
    | NONTERM_Main
    | NONTERM_Topdecs
    | NONTERM_Topdec
    | NONTERM_Vardec
    | NONTERM_Vardesc
    | NONTERM_Fundec
    | NONTERM_Paramdecs
    | NONTERM_Paramdecs1
    | NONTERM_Block
    | NONTERM_StmtOrDecSeq
    | NONTERM_Stmt
    | NONTERM_StmtM
    | NONTERM_StmtU
    | NONTERM_Expr
    | NONTERM_ExprNotAccess
    | NONTERM_AtExprNotAccess
    | NONTERM_Access
    | NONTERM_Exprs
    | NONTERM_Exprs1
    | NONTERM_Const
    | NONTERM_Type

// This function maps tokens to integer indexes
let tagOfToken (t:token) = 
  match t with
  | EOF  -> 0 
  | LPAR  -> 1 
  | RPAR  -> 2 
  | LBRACE  -> 3 
  | RBRACE  -> 4 
  | LBRACK  -> 5 
  | RBRACK  -> 6 
  | SEMI  -> 7 
  | COMMA  -> 8 
  | ASSIGN  -> 9 
  | AMP  -> 10 
  | NOT  -> 11 
  | SEQOR  -> 12 
  | SEQAND  -> 13 
  | EQ  -> 14 
  | NE  -> 15 
  | GT  -> 16 
  | LT  -> 17 
  | GE  -> 18 
  | LE  -> 19 
  | PLUS  -> 20 
  | MINUS  -> 21 
  | TIMES  -> 22 
  | DIV  -> 23 
  | MOD  -> 24 
  | NIL  -> 25 
  | CONS  -> 26 
  | CAR  -> 27 
  | CDR  -> 28 
  | DYNAMIC  -> 29 
  | SETCAR  -> 30 
  | SETCDR  -> 31 
  | CHAR  -> 32 
  | ELSE  -> 33 
  | IF  -> 34 
  | INT  -> 35 
  | NULL  -> 36 
  | PRINT  -> 37 
  | PRINTLN  -> 38 
  | RETURN  -> 39 
  | VOID  -> 40 
  | WHILE  -> 41 
  | CSTSTRING _ -> 42 
  | NAME _ -> 43 
  | CSTINT _ -> 44 
  | CSTBOOL _ -> 45 

// This function maps integer indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_EOF 
  | 1 -> TOKEN_LPAR 
  | 2 -> TOKEN_RPAR 
  | 3 -> TOKEN_LBRACE 
  | 4 -> TOKEN_RBRACE 
  | 5 -> TOKEN_LBRACK 
  | 6 -> TOKEN_RBRACK 
  | 7 -> TOKEN_SEMI 
  | 8 -> TOKEN_COMMA 
  | 9 -> TOKEN_ASSIGN 
  | 10 -> TOKEN_AMP 
  | 11 -> TOKEN_NOT 
  | 12 -> TOKEN_SEQOR 
  | 13 -> TOKEN_SEQAND 
  | 14 -> TOKEN_EQ 
  | 15 -> TOKEN_NE 
  | 16 -> TOKEN_GT 
  | 17 -> TOKEN_LT 
  | 18 -> TOKEN_GE 
  | 19 -> TOKEN_LE 
  | 20 -> TOKEN_PLUS 
  | 21 -> TOKEN_MINUS 
  | 22 -> TOKEN_TIMES 
  | 23 -> TOKEN_DIV 
  | 24 -> TOKEN_MOD 
  | 25 -> TOKEN_NIL 
  | 26 -> TOKEN_CONS 
  | 27 -> TOKEN_CAR 
  | 28 -> TOKEN_CDR 
  | 29 -> TOKEN_DYNAMIC 
  | 30 -> TOKEN_SETCAR 
  | 31 -> TOKEN_SETCDR 
  | 32 -> TOKEN_CHAR 
  | 33 -> TOKEN_ELSE 
  | 34 -> TOKEN_IF 
  | 35 -> TOKEN_INT 
  | 36 -> TOKEN_NULL 
  | 37 -> TOKEN_PRINT 
  | 38 -> TOKEN_PRINTLN 
  | 39 -> TOKEN_RETURN 
  | 40 -> TOKEN_VOID 
  | 41 -> TOKEN_WHILE 
  | 42 -> TOKEN_CSTSTRING 
  | 43 -> TOKEN_NAME 
  | 44 -> TOKEN_CSTINT 
  | 45 -> TOKEN_CSTBOOL 
  | 48 -> TOKEN_end_of_input
  | 46 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startMain 
    | 1 -> NONTERM_Main 
    | 2 -> NONTERM_Topdecs 
    | 3 -> NONTERM_Topdecs 
    | 4 -> NONTERM_Topdec 
    | 5 -> NONTERM_Topdec 
    | 6 -> NONTERM_Vardec 
    | 7 -> NONTERM_Vardesc 
    | 8 -> NONTERM_Vardesc 
    | 9 -> NONTERM_Vardesc 
    | 10 -> NONTERM_Vardesc 
    | 11 -> NONTERM_Vardesc 
    | 12 -> NONTERM_Fundec 
    | 13 -> NONTERM_Fundec 
    | 14 -> NONTERM_Paramdecs 
    | 15 -> NONTERM_Paramdecs 
    | 16 -> NONTERM_Paramdecs1 
    | 17 -> NONTERM_Paramdecs1 
    | 18 -> NONTERM_Block 
    | 19 -> NONTERM_StmtOrDecSeq 
    | 20 -> NONTERM_StmtOrDecSeq 
    | 21 -> NONTERM_StmtOrDecSeq 
    | 22 -> NONTERM_Stmt 
    | 23 -> NONTERM_Stmt 
    | 24 -> NONTERM_StmtM 
    | 25 -> NONTERM_StmtM 
    | 26 -> NONTERM_StmtM 
    | 27 -> NONTERM_StmtM 
    | 28 -> NONTERM_StmtM 
    | 29 -> NONTERM_StmtM 
    | 30 -> NONTERM_StmtU 
    | 31 -> NONTERM_StmtU 
    | 32 -> NONTERM_StmtU 
    | 33 -> NONTERM_Expr 
    | 34 -> NONTERM_Expr 
    | 35 -> NONTERM_ExprNotAccess 
    | 36 -> NONTERM_ExprNotAccess 
    | 37 -> NONTERM_ExprNotAccess 
    | 38 -> NONTERM_ExprNotAccess 
    | 39 -> NONTERM_ExprNotAccess 
    | 40 -> NONTERM_ExprNotAccess 
    | 41 -> NONTERM_ExprNotAccess 
    | 42 -> NONTERM_ExprNotAccess 
    | 43 -> NONTERM_ExprNotAccess 
    | 44 -> NONTERM_ExprNotAccess 
    | 45 -> NONTERM_ExprNotAccess 
    | 46 -> NONTERM_ExprNotAccess 
    | 47 -> NONTERM_ExprNotAccess 
    | 48 -> NONTERM_ExprNotAccess 
    | 49 -> NONTERM_ExprNotAccess 
    | 50 -> NONTERM_ExprNotAccess 
    | 51 -> NONTERM_ExprNotAccess 
    | 52 -> NONTERM_ExprNotAccess 
    | 53 -> NONTERM_ExprNotAccess 
    | 54 -> NONTERM_AtExprNotAccess 
    | 55 -> NONTERM_AtExprNotAccess 
    | 56 -> NONTERM_AtExprNotAccess 
    | 57 -> NONTERM_AtExprNotAccess 
    | 58 -> NONTERM_AtExprNotAccess 
    | 59 -> NONTERM_AtExprNotAccess 
    | 60 -> NONTERM_AtExprNotAccess 
    | 61 -> NONTERM_AtExprNotAccess 
    | 62 -> NONTERM_AtExprNotAccess 
    | 63 -> NONTERM_Access 
    | 64 -> NONTERM_Access 
    | 65 -> NONTERM_Access 
    | 66 -> NONTERM_Access 
    | 67 -> NONTERM_Access 
    | 68 -> NONTERM_Exprs 
    | 69 -> NONTERM_Exprs 
    | 70 -> NONTERM_Exprs1 
    | 71 -> NONTERM_Exprs1 
    | 72 -> NONTERM_Const 
    | 73 -> NONTERM_Const 
    | 74 -> NONTERM_Const 
    | 75 -> NONTERM_Const 
    | 76 -> NONTERM_Type 
    | 77 -> NONTERM_Type 
    | 78 -> NONTERM_Type 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 48 
let _fsyacc_tagOfErrorTerminal = 46

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | EOF  -> "EOF" 
  | LPAR  -> "LPAR" 
  | RPAR  -> "RPAR" 
  | LBRACE  -> "LBRACE" 
  | RBRACE  -> "RBRACE" 
  | LBRACK  -> "LBRACK" 
  | RBRACK  -> "RBRACK" 
  | SEMI  -> "SEMI" 
  | COMMA  -> "COMMA" 
  | ASSIGN  -> "ASSIGN" 
  | AMP  -> "AMP" 
  | NOT  -> "NOT" 
  | SEQOR  -> "SEQOR" 
  | SEQAND  -> "SEQAND" 
  | EQ  -> "EQ" 
  | NE  -> "NE" 
  | GT  -> "GT" 
  | LT  -> "LT" 
  | GE  -> "GE" 
  | LE  -> "LE" 
  | PLUS  -> "PLUS" 
  | MINUS  -> "MINUS" 
  | TIMES  -> "TIMES" 
  | DIV  -> "DIV" 
  | MOD  -> "MOD" 
  | NIL  -> "NIL" 
  | CONS  -> "CONS" 
  | CAR  -> "CAR" 
  | CDR  -> "CDR" 
  | DYNAMIC  -> "DYNAMIC" 
  | SETCAR  -> "SETCAR" 
  | SETCDR  -> "SETCDR" 
  | CHAR  -> "CHAR" 
  | ELSE  -> "ELSE" 
  | IF  -> "IF" 
  | INT  -> "INT" 
  | NULL  -> "NULL" 
  | PRINT  -> "PRINT" 
  | PRINTLN  -> "PRINTLN" 
  | RETURN  -> "RETURN" 
  | VOID  -> "VOID" 
  | WHILE  -> "WHILE" 
  | CSTSTRING _ -> "CSTSTRING" 
  | NAME _ -> "NAME" 
  | CSTINT _ -> "CSTINT" 
  | CSTBOOL _ -> "CSTBOOL" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | EOF  -> (null : System.Object) 
  | LPAR  -> (null : System.Object) 
  | RPAR  -> (null : System.Object) 
  | LBRACE  -> (null : System.Object) 
  | RBRACE  -> (null : System.Object) 
  | LBRACK  -> (null : System.Object) 
  | RBRACK  -> (null : System.Object) 
  | SEMI  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | ASSIGN  -> (null : System.Object) 
  | AMP  -> (null : System.Object) 
  | NOT  -> (null : System.Object) 
  | SEQOR  -> (null : System.Object) 
  | SEQAND  -> (null : System.Object) 
  | EQ  -> (null : System.Object) 
  | NE  -> (null : System.Object) 
  | GT  -> (null : System.Object) 
  | LT  -> (null : System.Object) 
  | GE  -> (null : System.Object) 
  | LE  -> (null : System.Object) 
  | PLUS  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | TIMES  -> (null : System.Object) 
  | DIV  -> (null : System.Object) 
  | MOD  -> (null : System.Object) 
  | NIL  -> (null : System.Object) 
  | CONS  -> (null : System.Object) 
  | CAR  -> (null : System.Object) 
  | CDR  -> (null : System.Object) 
  | DYNAMIC  -> (null : System.Object) 
  | SETCAR  -> (null : System.Object) 
  | SETCDR  -> (null : System.Object) 
  | CHAR  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | INT  -> (null : System.Object) 
  | NULL  -> (null : System.Object) 
  | PRINT  -> (null : System.Object) 
  | PRINTLN  -> (null : System.Object) 
  | RETURN  -> (null : System.Object) 
  | VOID  -> (null : System.Object) 
  | WHILE  -> (null : System.Object) 
  | CSTSTRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CSTINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CSTBOOL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 2us; 65535us; 0us; 2us; 4us; 5us; 2us; 65535us; 0us; 4us; 4us; 4us; 8us; 65535us; 0us; 6us; 4us; 6us; 25us; 34us; 29us; 34us; 35us; 34us; 37us; 42us; 40us; 42us; 43us; 42us; 4us; 65535us; 9us; 11us; 10us; 11us; 14us; 15us; 16us; 17us; 2us; 65535us; 0us; 8us; 4us; 8us; 2us; 65535us; 25us; 26us; 29us; 30us; 3us; 65535us; 25us; 33us; 29us; 33us; 35us; 36us; 8us; 65535us; 27us; 28us; 31us; 32us; 37us; 54us; 40us; 54us; 43us; 54us; 58us; 54us; 59us; 54us; 64us; 54us; 3us; 65535us; 37us; 38us; 40us; 41us; 43us; 44us; 4us; 65535us; 37us; 40us; 40us; 40us; 43us; 40us; 58us; 67us; 6us; 65535us; 37us; 45us; 40us; 45us; 43us; 45us; 58us; 46us; 59us; 60us; 64us; 65us; 6us; 65535us; 37us; 47us; 40us; 47us; 43us; 47us; 58us; 47us; 59us; 66us; 64us; 68us; 37us; 65535us; 37us; 48us; 40us; 48us; 43us; 48us; 50us; 52us; 56us; 57us; 58us; 48us; 59us; 48us; 62us; 63us; 64us; 48us; 74us; 75us; 77us; 108us; 80us; 81us; 82us; 83us; 109us; 85us; 110us; 86us; 111us; 87us; 112us; 88us; 113us; 89us; 114us; 90us; 115us; 91us; 116us; 92us; 117us; 93us; 118us; 94us; 119us; 95us; 120us; 96us; 121us; 98us; 123us; 97us; 129us; 99us; 130us; 100us; 133us; 101us; 136us; 102us; 139us; 103us; 140us; 104us; 143us; 105us; 144us; 106us; 153us; 107us; 156us; 108us; 37us; 65535us; 37us; 71us; 40us; 71us; 43us; 71us; 50us; 71us; 56us; 71us; 58us; 71us; 59us; 71us; 62us; 71us; 64us; 71us; 74us; 71us; 77us; 71us; 80us; 71us; 82us; 71us; 109us; 71us; 110us; 71us; 111us; 71us; 112us; 71us; 113us; 71us; 114us; 71us; 115us; 71us; 116us; 71us; 117us; 71us; 118us; 71us; 119us; 71us; 120us; 71us; 121us; 71us; 123us; 72us; 129us; 71us; 130us; 71us; 133us; 71us; 136us; 71us; 139us; 71us; 140us; 71us; 143us; 71us; 144us; 71us; 153us; 71us; 156us; 71us; 38us; 65535us; 37us; 73us; 40us; 73us; 43us; 73us; 50us; 73us; 56us; 73us; 58us; 73us; 59us; 73us; 62us; 73us; 64us; 73us; 74us; 73us; 77us; 73us; 80us; 73us; 82us; 73us; 109us; 73us; 110us; 73us; 111us; 73us; 112us; 73us; 113us; 73us; 114us; 73us; 115us; 73us; 116us; 73us; 117us; 73us; 118us; 73us; 119us; 73us; 120us; 73us; 121us; 73us; 123us; 73us; 129us; 73us; 130us; 73us; 133us; 73us; 136us; 73us; 139us; 73us; 140us; 73us; 143us; 73us; 144us; 73us; 150us; 152us; 153us; 73us; 156us; 73us; 40us; 65535us; 37us; 70us; 40us; 70us; 43us; 70us; 50us; 70us; 56us; 70us; 58us; 70us; 59us; 70us; 62us; 70us; 64us; 70us; 74us; 70us; 77us; 70us; 80us; 70us; 82us; 70us; 109us; 70us; 110us; 70us; 111us; 70us; 112us; 70us; 113us; 70us; 114us; 70us; 115us; 70us; 116us; 70us; 117us; 70us; 118us; 70us; 119us; 70us; 120us; 70us; 121us; 70us; 123us; 69us; 125us; 126us; 129us; 70us; 130us; 70us; 133us; 70us; 136us; 70us; 139us; 70us; 140us; 70us; 143us; 70us; 144us; 70us; 147us; 148us; 150us; 151us; 153us; 70us; 156us; 70us; 1us; 65535us; 77us; 78us; 2us; 65535us; 77us; 155us; 156us; 157us; 38us; 65535us; 37us; 122us; 40us; 122us; 43us; 122us; 50us; 122us; 56us; 122us; 58us; 122us; 59us; 122us; 62us; 122us; 64us; 122us; 74us; 122us; 77us; 122us; 80us; 122us; 82us; 122us; 109us; 122us; 110us; 122us; 111us; 122us; 112us; 122us; 113us; 122us; 114us; 122us; 115us; 122us; 116us; 122us; 117us; 122us; 118us; 122us; 119us; 122us; 120us; 122us; 121us; 122us; 123us; 122us; 129us; 122us; 130us; 122us; 133us; 122us; 136us; 122us; 139us; 122us; 140us; 122us; 143us; 122us; 144us; 122us; 150us; 122us; 153us; 122us; 156us; 122us; 8us; 65535us; 0us; 10us; 4us; 10us; 25us; 9us; 29us; 9us; 35us; 9us; 37us; 9us; 40us; 9us; 43us; 9us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 6us; 9us; 18us; 23us; 26us; 29us; 33us; 42us; 46us; 51us; 58us; 65us; 103us; 141us; 180us; 221us; 223us; 226us; 265us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 3us; 1us; 3us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 6us; 2us; 6us; 13us; 3us; 6us; 10us; 11us; 1us; 7us; 2us; 7us; 13us; 1us; 8us; 3us; 8us; 10us; 11us; 1us; 9us; 3us; 9us; 10us; 11us; 1us; 9us; 2us; 10us; 11us; 1us; 10us; 1us; 11us; 1us; 11us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 15us; 2us; 16us; 17us; 1us; 17us; 1us; 17us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 20us; 1us; 20us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 22us; 3us; 22us; 28us; 30us; 1us; 23us; 14us; 24us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 24us; 2us; 25us; 26us; 1us; 25us; 14us; 26us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 26us; 1us; 27us; 3us; 28us; 30us; 31us; 3us; 28us; 30us; 31us; 16us; 28us; 30us; 31us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 3us; 28us; 30us; 31us; 2us; 28us; 30us; 1us; 28us; 2us; 29us; 32us; 2us; 29us; 32us; 15us; 29us; 32us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 2us; 29us; 32us; 1us; 29us; 1us; 30us; 1us; 31us; 1us; 32us; 4us; 33us; 36us; 64us; 67us; 3us; 33us; 36us; 67us; 1us; 34us; 2us; 34us; 55us; 1us; 35us; 1us; 36us; 14us; 36us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 2us; 37us; 63us; 1us; 37us; 1us; 37us; 1us; 37us; 1us; 38us; 14us; 38us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 39us; 14us; 39us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 40us; 14us; 41us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 52us; 53us; 13us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 58us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 58us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 59us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 60us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 61us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 61us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 62us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 62us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 67us; 15us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 70us; 71us; 1us; 41us; 1us; 42us; 1us; 43us; 1us; 44us; 1us; 45us; 1us; 46us; 1us; 47us; 1us; 48us; 1us; 49us; 1us; 50us; 1us; 51us; 1us; 52us; 1us; 53us; 1us; 54us; 2us; 55us; 64us; 1us; 55us; 1us; 56us; 2us; 56us; 67us; 1us; 57us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 59us; 1us; 59us; 1us; 59us; 1us; 60us; 1us; 60us; 1us; 60us; 1us; 61us; 1us; 61us; 1us; 61us; 1us; 61us; 1us; 62us; 1us; 62us; 1us; 62us; 1us; 62us; 1us; 63us; 1us; 64us; 2us; 64us; 67us; 1us; 64us; 2us; 65us; 66us; 2us; 65us; 67us; 1us; 66us; 1us; 67us; 1us; 67us; 1us; 69us; 1us; 71us; 1us; 71us; 1us; 72us; 1us; 73us; 1us; 74us; 1us; 74us; 1us; 75us; 1us; 76us; 1us; 77us; 1us; 78us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 23us; 27us; 29us; 32us; 34us; 38us; 40us; 44us; 46us; 49us; 51us; 53us; 55us; 57us; 59us; 61us; 63us; 65us; 67us; 69us; 71us; 73us; 75us; 77us; 80us; 82us; 84us; 86us; 88us; 90us; 92us; 94us; 96us; 98us; 100us; 102us; 106us; 108us; 123us; 125us; 128us; 130us; 145us; 147us; 149us; 153us; 157us; 174us; 178us; 181us; 183us; 186us; 189us; 205us; 208us; 210us; 212us; 214us; 216us; 221us; 225us; 227us; 230us; 232us; 234us; 249us; 252us; 254us; 256us; 258us; 260us; 275us; 277us; 292us; 294us; 309us; 324us; 339us; 354us; 369us; 384us; 399us; 414us; 429us; 444us; 459us; 474us; 488us; 503us; 518us; 533us; 548us; 563us; 578us; 593us; 608us; 623us; 638us; 654us; 656us; 658us; 660us; 662us; 664us; 666us; 668us; 670us; 672us; 674us; 676us; 678us; 680us; 682us; 685us; 687us; 689us; 692us; 694us; 696us; 698us; 700us; 702us; 704us; 706us; 708us; 710us; 712us; 714us; 716us; 718us; 720us; 722us; 724us; 726us; 728us; 730us; 732us; 734us; 737us; 739us; 742us; 745us; 747us; 749us; 751us; 753us; 755us; 757us; 759us; 761us; 763us; 765us; 767us; 769us; 771us; |]
let _fsyacc_action_rows = 166
let _fsyacc_actionTableElements = [|4us; 16386us; 29us; 165us; 32us; 164us; 35us; 163us; 40us; 23us; 0us; 49152us; 1us; 32768us; 0us; 3us; 0us; 16385us; 4us; 16386us; 29us; 165us; 32us; 164us; 35us; 163us; 40us; 23us; 0us; 16387us; 1us; 32768us; 7us; 7us; 0us; 16388us; 0us; 16389us; 3us; 32768us; 1us; 16us; 22us; 14us; 43us; 12us; 3us; 32768us; 1us; 16us; 22us; 14us; 43us; 13us; 1us; 16390us; 5us; 19us; 0us; 16391us; 1us; 16391us; 1us; 29us; 3us; 32768us; 1us; 16us; 22us; 14us; 43us; 12us; 1us; 16392us; 5us; 19us; 3us; 32768us; 1us; 16us; 22us; 14us; 43us; 12us; 2us; 32768us; 2us; 18us; 5us; 19us; 0us; 16393us; 2us; 32768us; 6us; 20us; 44us; 21us; 0us; 16394us; 1us; 32768us; 6us; 22us; 0us; 16395us; 1us; 32768us; 43us; 24us; 1us; 32768us; 1us; 25us; 3us; 16398us; 29us; 165us; 32us; 164us; 35us; 163us; 1us; 32768us; 2us; 27us; 1us; 32768us; 3us; 37us; 0us; 16396us; 3us; 16398us; 29us; 165us; 32us; 164us; 35us; 163us; 1us; 32768us; 2us; 31us; 1us; 32768us; 3us; 37us; 0us; 16397us; 0us; 16399us; 1us; 16400us; 8us; 35us; 3us; 32768us; 29us; 165us; 32us; 164us; 35us; 163us; 0us; 16401us; 24us; 16403us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 29us; 165us; 30us; 138us; 31us; 142us; 32us; 164us; 34us; 55us; 35us; 163us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 1us; 32768us; 4us; 39us; 0us; 16402us; 24us; 16403us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 29us; 165us; 30us; 138us; 31us; 142us; 32us; 164us; 34us; 55us; 35us; 163us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16404us; 1us; 32768us; 7us; 43us; 24us; 16403us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 29us; 165us; 30us; 138us; 31us; 142us; 32us; 164us; 34us; 55us; 35us; 163us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16405us; 0us; 16406us; 1us; 16406us; 33us; 59us; 0us; 16407us; 14us; 32768us; 7us; 49us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 0us; 16408us; 18us; 32768us; 1us; 123us; 7us; 51us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16409us; 14us; 32768us; 7us; 53us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 0us; 16410us; 0us; 16411us; 1us; 32768us; 1us; 56us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 14us; 32768us; 2us; 58us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 21us; 32768us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 34us; 55us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 21us; 32768us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 34us; 55us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16412us; 1us; 32768us; 1us; 62us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 14us; 32768us; 2us; 64us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 21us; 32768us; 1us; 123us; 3us; 37us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 34us; 55us; 36us; 162us; 37us; 82us; 38us; 84us; 39us; 50us; 41us; 61us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16413us; 0us; 16414us; 0us; 16415us; 0us; 16416us; 3us; 16417us; 2us; 149us; 5us; 153us; 9us; 74us; 2us; 16417us; 5us; 153us; 9us; 74us; 0us; 16418us; 1us; 16418us; 2us; 124us; 0us; 16419us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 13us; 16420us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 1us; 16447us; 1us; 77us; 17us; 16452us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 1us; 32768us; 2us; 79us; 0us; 16421us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16422us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 13us; 16423us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 0us; 16424us; 3us; 16425us; 22us; 111us; 23us; 112us; 24us; 113us; 3us; 16426us; 22us; 111us; 23us; 112us; 24us; 113us; 0us; 16427us; 0us; 16428us; 0us; 16429us; 9us; 16430us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 9us; 16431us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 9us; 16432us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 9us; 16433us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 9us; 16434us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 9us; 16435us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 11us; 16436us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 13us; 32768us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 12us; 16437us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 8us; 130us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 2us; 131us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 2us; 134us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 2us; 137us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 8us; 140us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 2us; 141us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 8us; 144us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 2us; 145us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 32768us; 6us; 154us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 14us; 16454us; 8us; 156us; 12us; 121us; 13us; 120us; 14us; 114us; 15us; 115us; 16us; 116us; 17us; 117us; 18us; 118us; 19us; 119us; 20us; 109us; 21us; 110us; 22us; 111us; 23us; 112us; 24us; 113us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16438us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16439us; 3us; 32768us; 1us; 147us; 22us; 150us; 43us; 146us; 1us; 16440us; 5us; 153us; 0us; 16441us; 1us; 32768us; 1us; 129us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16442us; 1us; 32768us; 1us; 133us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16443us; 1us; 32768us; 1us; 136us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16444us; 1us; 32768us; 1us; 139us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16445us; 1us; 32768us; 1us; 143us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16446us; 0us; 16447us; 3us; 32768us; 1us; 147us; 22us; 150us; 43us; 146us; 2us; 32768us; 2us; 149us; 5us; 153us; 0us; 16448us; 14us; 32768us; 1us; 123us; 10us; 125us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 43us; 146us; 44us; 158us; 45us; 159us; 1us; 16449us; 5us; 153us; 0us; 16450us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16451us; 0us; 16453us; 17us; 32768us; 1us; 123us; 10us; 125us; 11us; 80us; 21us; 160us; 22us; 150us; 25us; 127us; 26us; 128us; 27us; 132us; 28us; 135us; 30us; 138us; 31us; 142us; 36us; 162us; 37us; 82us; 38us; 84us; 43us; 76us; 44us; 158us; 45us; 159us; 0us; 16455us; 0us; 16456us; 0us; 16457us; 1us; 32768us; 44us; 161us; 0us; 16458us; 0us; 16459us; 0us; 16460us; 0us; 16461us; 0us; 16462us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 5us; 6us; 8us; 9us; 14us; 15us; 17us; 18us; 19us; 23us; 27us; 29us; 30us; 32us; 36us; 38us; 42us; 45us; 46us; 49us; 50us; 52us; 53us; 55us; 57us; 61us; 63us; 65us; 66us; 70us; 72us; 74us; 75us; 76us; 78us; 82us; 83us; 108us; 110us; 111us; 136us; 137us; 139us; 164us; 165us; 166us; 168us; 169us; 184us; 185us; 204us; 205us; 220us; 221us; 222us; 224us; 242us; 257us; 279us; 301us; 302us; 304us; 322us; 337us; 359us; 360us; 361us; 362us; 363us; 367us; 370us; 371us; 373us; 374us; 392us; 406us; 408us; 426us; 428us; 429us; 447us; 448us; 466us; 480us; 481us; 485us; 489us; 490us; 491us; 492us; 502us; 512us; 522us; 532us; 542us; 552us; 564us; 578us; 591us; 606us; 621us; 636us; 651us; 666us; 681us; 696us; 711us; 726us; 741us; 759us; 777us; 795us; 813us; 831us; 849us; 867us; 885us; 903us; 921us; 939us; 957us; 975us; 976us; 994us; 995us; 999us; 1001us; 1002us; 1004us; 1022us; 1040us; 1041us; 1043us; 1061us; 1062us; 1064us; 1082us; 1083us; 1085us; 1103us; 1121us; 1122us; 1124us; 1142us; 1160us; 1161us; 1162us; 1166us; 1169us; 1170us; 1185us; 1187us; 1188us; 1206us; 1207us; 1208us; 1226us; 1227us; 1228us; 1229us; 1231us; 1232us; 1233us; 1234us; 1235us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 2us; 0us; 2us; 2us; 1us; 2us; 1us; 2us; 3us; 3us; 4us; 6us; 6us; 0us; 1us; 1us; 3us; 3us; 0us; 2us; 3us; 1us; 1us; 2us; 2us; 3us; 1us; 7us; 5us; 7us; 5us; 5us; 1us; 1us; 1us; 3us; 4us; 2us; 2us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 3us; 2us; 1us; 6us; 4us; 4us; 6us; 6us; 1us; 3us; 2us; 2us; 4us; 0us; 1us; 1us; 3us; 1us; 1us; 2us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 3us; 3us; 4us; 5us; 5us; 5us; 5us; 5us; 6us; 6us; 7us; 7us; 8us; 8us; 9us; 10us; 10us; 10us; 11us; 11us; 12us; 12us; 12us; 12us; 12us; 12us; 13us; 13us; 13us; 14us; 14us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 16us; 16us; 16us; 16us; 16us; 16us; 16us; 16us; 16us; 17us; 17us; 17us; 17us; 17us; 18us; 18us; 19us; 19us; 20us; 20us; 20us; 20us; 21us; 21us; 21us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 16385us; 65535us; 16387us; 65535us; 16388us; 16389us; 65535us; 65535us; 65535us; 16391us; 65535us; 65535us; 65535us; 65535us; 65535us; 16393us; 65535us; 16394us; 65535us; 16395us; 65535us; 65535us; 65535us; 65535us; 65535us; 16396us; 65535us; 65535us; 65535us; 16397us; 16399us; 65535us; 65535us; 16401us; 65535us; 65535us; 16402us; 65535us; 16404us; 65535us; 65535us; 16405us; 16406us; 65535us; 16407us; 65535us; 16408us; 65535us; 16409us; 65535us; 16410us; 16411us; 65535us; 65535us; 65535us; 65535us; 65535us; 16412us; 65535us; 65535us; 65535us; 65535us; 16413us; 16414us; 16415us; 16416us; 65535us; 65535us; 16418us; 65535us; 16419us; 65535us; 65535us; 65535us; 65535us; 65535us; 16421us; 65535us; 65535us; 65535us; 65535us; 16424us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16438us; 65535us; 16439us; 65535us; 65535us; 16441us; 65535us; 65535us; 65535us; 16442us; 65535us; 65535us; 16443us; 65535us; 65535us; 16444us; 65535us; 65535us; 65535us; 16445us; 65535us; 65535us; 65535us; 16446us; 16447us; 65535us; 65535us; 16448us; 65535us; 65535us; 16450us; 65535us; 16451us; 16453us; 65535us; 16455us; 16456us; 16457us; 65535us; 16458us; 16459us; 16460us; 16461us; 16462us; |]
let _fsyacc_reductions ()  =    [| 
# 443 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> Absyn.program in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : 'gentype__startMain));
# 452 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Topdecs in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "CPar.fsy"
                                                               Prog _1 
                   )
# 42 "CPar.fsy"
                 : Absyn.program));
# 463 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 46 "CPar.fsy"
                                                               [] 
                   )
# 46 "CPar.fsy"
                 : 'gentype_Topdecs));
# 473 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Topdec in
            let _2 = parseState.GetInput(2) :?> 'gentype_Topdecs in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 47 "CPar.fsy"
                                                               _1 :: _2 
                   )
# 47 "CPar.fsy"
                 : 'gentype_Topdecs));
# 485 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardec in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 51 "CPar.fsy"
                                                               Vardec (fst _1, snd _1) 
                   )
# 51 "CPar.fsy"
                 : 'gentype_Topdec));
# 496 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Fundec in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 52 "CPar.fsy"
                                                               _1 
                   )
# 52 "CPar.fsy"
                 : 'gentype_Topdec));
# 507 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Type in
            let _2 = parseState.GetInput(2) :?> 'gentype_Vardesc in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 56 "CPar.fsy"
                                                               ((fst _2) _1, snd _2) 
                   )
# 56 "CPar.fsy"
                 : 'gentype_Vardec));
# 519 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> string in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 60 "CPar.fsy"
                                                               ((fun t -> t), _1)                      
                   )
# 60 "CPar.fsy"
                 : 'gentype_Vardesc));
# 530 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Vardesc in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 61 "CPar.fsy"
                                                               compose1 TypP _2                        
                   )
# 61 "CPar.fsy"
                 : 'gentype_Vardesc));
# 541 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Vardesc in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 62 "CPar.fsy"
                                                               _2                                      
                   )
# 62 "CPar.fsy"
                 : 'gentype_Vardesc));
# 552 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardesc in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 63 "CPar.fsy"
                                                               compose1 (fun t -> TypA(t, None)) _1    
                   )
# 63 "CPar.fsy"
                 : 'gentype_Vardesc));
# 563 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardesc in
            let _3 = parseState.GetInput(3) :?> int in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "CPar.fsy"
                                                               compose1 (fun t -> TypA(t, Some _3)) _1 
                   )
# 64 "CPar.fsy"
                 : 'gentype_Vardesc));
# 575 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> string in
            let _4 = parseState.GetInput(4) :?> 'gentype_Paramdecs in
            let _6 = parseState.GetInput(6) :?> 'gentype_Block in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 68 "CPar.fsy"
                                                               Fundec(None,     _2, _4, _6) 
                   )
# 68 "CPar.fsy"
                 : 'gentype_Fundec));
# 588 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Type in
            let _2 = parseState.GetInput(2) :?> string in
            let _4 = parseState.GetInput(4) :?> 'gentype_Paramdecs in
            let _6 = parseState.GetInput(6) :?> 'gentype_Block in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "CPar.fsy"
                                                               Fundec(Some(_1), _2, _4, _6) 
                   )
# 69 "CPar.fsy"
                 : 'gentype_Fundec));
# 602 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "CPar.fsy"
                                                               [] 
                   )
# 73 "CPar.fsy"
                 : 'gentype_Paramdecs));
# 612 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Paramdecs1 in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 74 "CPar.fsy"
                                                               _1 
                   )
# 74 "CPar.fsy"
                 : 'gentype_Paramdecs));
# 623 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardec in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 78 "CPar.fsy"
                                                               [_1]     
                   )
# 78 "CPar.fsy"
                 : 'gentype_Paramdecs1));
# 634 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardec in
            let _3 = parseState.GetInput(3) :?> 'gentype_Paramdecs1 in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 79 "CPar.fsy"
                                                               _1 :: _3 
                   )
# 79 "CPar.fsy"
                 : 'gentype_Paramdecs1));
# 646 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_StmtOrDecSeq in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 83 "CPar.fsy"
                                                               Block _2 
                   )
# 83 "CPar.fsy"
                 : 'gentype_Block));
# 657 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 87 "CPar.fsy"
                                                               [] 
                   )
# 87 "CPar.fsy"
                 : 'gentype_StmtOrDecSeq));
# 667 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Stmt in
            let _2 = parseState.GetInput(2) :?> 'gentype_StmtOrDecSeq in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "CPar.fsy"
                                                               Stmt _1 :: _2 
                   )
# 88 "CPar.fsy"
                 : 'gentype_StmtOrDecSeq));
# 679 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Vardec in
            let _3 = parseState.GetInput(3) :?> 'gentype_StmtOrDecSeq in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "CPar.fsy"
                                                               Dec (fst _1, snd _1) :: _3 
                   )
# 89 "CPar.fsy"
                 : 'gentype_StmtOrDecSeq));
# 691 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_StmtM in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 93 "CPar.fsy"
                                                               _1 
                   )
# 93 "CPar.fsy"
                 : 'gentype_Stmt));
# 702 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_StmtU in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 94 "CPar.fsy"
                                                               _1 
                   )
# 94 "CPar.fsy"
                 : 'gentype_Stmt));
# 713 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 98 "CPar.fsy"
                                                               Expr(_1)              
                   )
# 98 "CPar.fsy"
                 : 'gentype_StmtM));
# 724 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 99 "CPar.fsy"
                                                               Return None           
                   )
# 99 "CPar.fsy"
                 : 'gentype_StmtM));
# 734 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 100 "CPar.fsy"
                                                               Return(Some(_2))      
                   )
# 100 "CPar.fsy"
                 : 'gentype_StmtM));
# 745 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Block in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 101 "CPar.fsy"
                                                               _1                    
                   )
# 101 "CPar.fsy"
                 : 'gentype_StmtM));
# 756 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_StmtM in
            let _7 = parseState.GetInput(7) :?> 'gentype_StmtM in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 102 "CPar.fsy"
                                                               If(_3, _5, _7)        
                   )
# 102 "CPar.fsy"
                 : 'gentype_StmtM));
# 769 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_StmtM in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 103 "CPar.fsy"
                                                               While(_3, _5)         
                   )
# 103 "CPar.fsy"
                 : 'gentype_StmtM));
# 781 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_StmtM in
            let _7 = parseState.GetInput(7) :?> 'gentype_StmtU in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 107 "CPar.fsy"
                                                               If(_3, _5, _7)        
                   )
# 107 "CPar.fsy"
                 : 'gentype_StmtU));
# 794 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_Stmt in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 108 "CPar.fsy"
                                                               If(_3, _5, Block [])  
                   )
# 108 "CPar.fsy"
                 : 'gentype_StmtU));
# 806 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_StmtU in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 109 "CPar.fsy"
                                                               While(_3, _5)         
                   )
# 109 "CPar.fsy"
                 : 'gentype_StmtU));
# 818 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Access in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 113 "CPar.fsy"
                                                               Access _1             
                   )
# 113 "CPar.fsy"
                 : 'gentype_Expr));
# 829 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_ExprNotAccess in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 114 "CPar.fsy"
                                                               _1                    
                   )
# 114 "CPar.fsy"
                 : 'gentype_Expr));
# 840 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_AtExprNotAccess in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 118 "CPar.fsy"
                                                               _1                    
                   )
# 118 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 851 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Access in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 119 "CPar.fsy"
                                                               Assign(_1, _3)        
                   )
# 119 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 863 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> string in
            let _3 = parseState.GetInput(3) :?> 'gentype_Exprs in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 120 "CPar.fsy"
                                                               Call(_1, _3)          
                   )
# 120 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 875 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 121 "CPar.fsy"
                                                               Prim1("!", _2)        
                   )
# 121 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 886 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 122 "CPar.fsy"
                                                               Prim1("printi", _2)   
                   )
# 122 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 897 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 123 "CPar.fsy"
                                                               Prim1("printc", nl)   
                   )
# 123 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 907 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 124 "CPar.fsy"
                                                               Prim2("+",  _1, _3)   
                   )
# 124 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 919 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 125 "CPar.fsy"
                                                               Prim2("-",  _1, _3)   
                   )
# 125 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 931 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 126 "CPar.fsy"
                                                               Prim2("*",  _1, _3)   
                   )
# 126 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 943 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 127 "CPar.fsy"
                                                               Prim2("/",  _1, _3)   
                   )
# 127 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 955 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 128 "CPar.fsy"
                                                               Prim2("%",  _1, _3)   
                   )
# 128 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 967 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 129 "CPar.fsy"
                                                               Prim2("==", _1, _3)   
                   )
# 129 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 979 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 130 "CPar.fsy"
                                                               Prim2("!=", _1, _3)   
                   )
# 130 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 991 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 131 "CPar.fsy"
                                                               Prim2(">",  _1, _3)   
                   )
# 131 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1003 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 132 "CPar.fsy"
                                                               Prim2("<",  _1, _3)   
                   )
# 132 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1015 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 133 "CPar.fsy"
                                                               Prim2(">=", _1, _3)   
                   )
# 133 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1027 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 134 "CPar.fsy"
                                                               Prim2("<=", _1, _3)   
                   )
# 134 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1039 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 135 "CPar.fsy"
                                                               Andalso(_1, _3)       
                   )
# 135 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1051 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 136 "CPar.fsy"
                                                               Orelse(_1, _3)        
                   )
# 136 "CPar.fsy"
                 : 'gentype_ExprNotAccess));
# 1063 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Const in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 140 "CPar.fsy"
                                                               CstI _1               
                   )
# 140 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1074 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_ExprNotAccess in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 141 "CPar.fsy"
                                                               _2                    
                   )
# 141 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1085 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Access in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 142 "CPar.fsy"
                                                               Addr _2               
                   )
# 142 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1096 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 143 "CPar.fsy"
                                                               CstN                  
                   )
# 143 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1106 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 144 "CPar.fsy"
                                                               Prim2("cons",_3,_5)   
                   )
# 144 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1118 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 145 "CPar.fsy"
                                                               Prim1("car", _3)      
                   )
# 145 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1129 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 146 "CPar.fsy"
                                                               Prim1("cdr", _3)      
                   )
# 146 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1140 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 147 "CPar.fsy"
                                                               Prim2("setcar",_3,_5) 
                   )
# 147 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1152 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            let _5 = parseState.GetInput(5) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 148 "CPar.fsy"
                                                               Prim2("setcdr",_3,_5) 
                   )
# 148 "CPar.fsy"
                 : 'gentype_AtExprNotAccess));
# 1164 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> string in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 152 "CPar.fsy"
                                                               AccVar _1             
                   )
# 152 "CPar.fsy"
                 : 'gentype_Access));
# 1175 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Access in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 153 "CPar.fsy"
                                                               _2                    
                   )
# 153 "CPar.fsy"
                 : 'gentype_Access));
# 1186 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_Access in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 154 "CPar.fsy"
                                                               AccDeref (Access _2)  
                   )
# 154 "CPar.fsy"
                 : 'gentype_Access));
# 1197 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> 'gentype_AtExprNotAccess in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 155 "CPar.fsy"
                                                               AccDeref _2           
                   )
# 155 "CPar.fsy"
                 : 'gentype_Access));
# 1208 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Access in
            let _3 = parseState.GetInput(3) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 156 "CPar.fsy"
                                                               AccIndex(_1, _3)      
                   )
# 156 "CPar.fsy"
                 : 'gentype_Access));
# 1220 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 160 "CPar.fsy"
                                                               []       
                   )
# 160 "CPar.fsy"
                 : 'gentype_Exprs));
# 1230 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Exprs1 in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 161 "CPar.fsy"
                                                               _1       
                   )
# 161 "CPar.fsy"
                 : 'gentype_Exprs));
# 1241 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 165 "CPar.fsy"
                                                               [_1]     
                   )
# 165 "CPar.fsy"
                 : 'gentype_Exprs1));
# 1252 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> 'gentype_Expr in
            let _3 = parseState.GetInput(3) :?> 'gentype_Exprs1 in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 166 "CPar.fsy"
                                                               _1 :: _3 
                   )
# 166 "CPar.fsy"
                 : 'gentype_Exprs1));
# 1264 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> int in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 170 "CPar.fsy"
                                                               _1       
                   )
# 170 "CPar.fsy"
                 : 'gentype_Const));
# 1275 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _1 = parseState.GetInput(1) :?> int in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 171 "CPar.fsy"
                                                               _1       
                   )
# 171 "CPar.fsy"
                 : 'gentype_Const));
# 1286 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            let _2 = parseState.GetInput(2) :?> int in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 172 "CPar.fsy"
                                                               - _2     
                   )
# 172 "CPar.fsy"
                 : 'gentype_Const));
# 1297 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 173 "CPar.fsy"
                                                               -1       
                   )
# 173 "CPar.fsy"
                 : 'gentype_Const));
# 1307 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 177 "CPar.fsy"
                                                               TypI     
                   )
# 177 "CPar.fsy"
                 : 'gentype_Type));
# 1317 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 178 "CPar.fsy"
                                                               TypC     
                   )
# 178 "CPar.fsy"
                 : 'gentype_Type));
# 1327 "CPar.fs"
        (fun (parseState : FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 179 "CPar.fsy"
                                                               TypD     
                   )
# 179 "CPar.fsy"
                 : 'gentype_Type));
|]
# 1338 "CPar.fs"
let tables : FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 49;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = tables.Interpret(lexer, lexbuf, startState)
let Main lexer lexbuf : Absyn.program =
    engine lexer lexbuf 0 :?> _
